// Copyright 2009 Christopher Smith
// 
// This file is part of smithers.extras.
// 
// smithers.extras is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option)
// any later version.
// 
// smithers.extras is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
// more details.
// 
// You should have received a copy of the GNU General Public License along with
// smithers.extras. If not, see <http://www.gnu.org/licenses/>.

package smithers.extras;

/**
 * Prints the numbers as said in the game of fizzbuzz, known as bizzbuzz in the
 * US.
 */
public class FizzBuzz {
    
    /**
     * Plays fizzbuzz. Prints the numbers 1 to 100, but replaces multiples of 5
     * and numbers with a digit 5 with {@code "fizz"} and multiples of 7 and
     * number with a digit 7 with {@code "buzz"}. <br>
     * If a number is given as an argument, this is used as the maximum number
     * instead of 100. If the argument {@code "-penhalagen"} is given, replaces
     * multiples of 9 and numbers with a digit 9 with {@code "penhalagen"} and
     * switches {@code "fizz"} and {@code "buzz"} each time this occurs.
     * 
     * @param args the arguments, if any
     */
    public static void main(String[] args) throws Exception {
        String output, iStr;
        String fizz = "fizz", buzz = "buzz", temp;
        int max = 100;
        boolean penhalagen = false;
        
        for (String arg : args) {
            if (arg.matches("\\d*"))
                max = Integer.parseInt(arg);
            else if (arg.equals("-penhalagen"))
                penhalagen = true;
            else if (arg.equals("-no-penhalagen"))
                penhalagen = false;
            else if (arg.equals("-h") || arg.equals("--help")) {
                System.out.println("smithers.extras.FizzBuzz -- plays the game of fizzbuzz.");
                return;
            }
        }
        
        for (int i=1; i<=Integer.parseInt(args[0]); i++) {
            output = "";
            iStr = Integer.toString(i);
            if ((i%5 == 0) || iStr.matches("\\d*5\\d*")) output += fizz;
            if ((i%7 == 0) || iStr.matches("\\d*7\\d*")) output += buzz;
            if (penhalagen && ((i%9 == 0) || iStr.matches("\\d*9\\d*"))) {
                output += "penhalagen";
                temp = fizz;
                fizz = buzz;
                buzz = temp;
            }
            if (output.equals("")) output = iStr;
            System.out.println(output);
        }
    }
    
}
